import React, { Component } from "react";
import { reduxForm, Field } from "redux-form";
import "./eventForm.scss";
import { customInput } from "../customFields/customInput/customInput";
import { customTextarea } from "../customFields/customTextarea/customTextarea";
import { customSelect } from "../customFields/customSelect/customSelect";
import { eventFormInitialValue, eventTypes } from "../../state/addEventInitialValue";
import { eventFormValidation } from "../../utils/eventFormValidation";

const EventReduxForm = ({
    handleSubmit,
    postNewEvent
}) => {

    const submit = value => {
        console.log('submit values', value)
        postNewEvent(value)
    };

    // const resetForm = () => {
    // 	reset();
    // 	resetInitValue();
    // }

    // onChangeHandler = e => {
    //     const { name, value, id } = e.target;

    //     this.setState(prevState => {
    //         const values = Object.keys(prevState.form).reduce((prev, elem) => {
    //             if (elem === name) return prev.concat(value);
    //             return prev.concat(prevState.form[elem].value);
    //         }, []);

    //         return {
    //             ...prevState,
    //             form: {
    //                 ...prevState.form,
    //                 [name]: {
    //                     ...prevState.form[name],
    //                     value,
    //                     // touch: true,
    //                     // fail: this.validator(prevState.form[name].validation, value)
    //                 },
    //                 // pictures: prevState.form.pictures.map(el => (el.id === +id ? { ...el, value } : el))
    //             },
    //             validForm: values.some(value => value)
    //         };
    //     });
    // };

    // render() {
    //     const { form, validForm } = this.state;
    //     const { error } = this.props;

    return (
        <form className="event-form__event-form__main" onSubmit={handleSubmit(submit)}>
            {console.log('eventFormInitialValue', eventFormInitialValue)}

            <img className="event-form__picture" src={eventFormInitialValue.mainBannerPicture} />
            <Field name="mainBannerPicture" className="input-box__wide" label="Main Banner Picture" component={customInput} />
            <Field name="title" label="Event Title" className="input-box__wide" required component={customInput} />
            <Field name="eventType" label="Event Type" required component={customSelect} >
                {eventTypes.map(elem => <option key={elem.id} value={elem.optionName}>{elem.optionName}</option>)}
            </Field>
            <Field name="eventDate" type="date" label="Event Date" required component={customInput} />
            <Field name="country" label="Country" required component={customInput} />
            <Field name="city" label="City" required component={customInput} />
            <Field name="overview" label="Overview" rows="10" placeholder='Enter event overview' component={customTextarea} />
            <Field name="contentPicture" label="Content Picture" className="input-box__wide" placeholder='Enter picture url' component={customInput} />
            <Field name="contentVideo" label="Content Video" className="input-box__wide" placeholder='Enter video url' component={customInput} />
            <Field name="marathoneDistancePrice" label="Marathone Distance Price" component={customInput} />
            <Field name="halfmarathoneDistancePrice" label="Halfmarathone Distance Price" component={customInput} />
            <Field name="ageLimit" label="Age Limit" component={customTextarea} />
            <Field name="awardMedals" label="Award Medals" component={customTextarea} />
            <Field name="maximumTime" label="Maximum Time" component={customTextarea} />
            <Field name="aidStations" label="Aid Stations" component={customTextarea} />
            <Field name="equipmentStorage" label="Equipment Storage" component={customTextarea} />
            <Field name="parking" label="Parking" component={customTextarea} />
            <Field name="refreshments" label="Refreshments" component={customTextarea} />
            <Field name="map" label="Map" className="input-box__wide" placeholder='Enter picture url' component={customInput} />

            <div className="event-form__control-box">
                <button className="event-form__submit-btn" >Add Event</button>
            </div>
        </form>
    );
}

export default reduxForm({ form: "eventForm", validate: eventFormValidation, enableReinitialize: true })(EventReduxForm);